using System;
using System.Drawing;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Tools;

namespace DockTest
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Tools.DockingManager dm;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.ComponentModel.IContainer components;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				dm.Dispose();
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.dm = new Syncfusion.Windows.Forms.Tools.DockingManager(this.components);
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			((System.ComponentModel.ISupportInitialize)(this.dm)).BeginInit();
			// 
			// dm
			// 
			this.dm.DockLayoutStream = ((System.IO.MemoryStream)(resources.GetObject("dm.DockLayoutStream")));
			this.dm.HostControl = this;
			this.dm.ShowToolTips = true;
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																											 this.menuItem1,
																											 this.menuItem2});
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.Text = "One";
			this.menuItem1.Click += new System.EventHandler(this.menuItem1_Click);
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 1;
			this.menuItem2.Text = "Two";
			this.menuItem2.Click += new System.EventHandler(this.menuItem2_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 273);
			this.IsMdiContainer = true;
			this.Menu = this.mainMenu1;
			this.Name = "Form1";
			this.Text = "Form1";
			this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.dm)).EndInit();

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
		}

		UserControl uc1, uc2, uc3, uc4;
		private void menuItem1_Click(object sender, System.EventArgs e)
		{
			dm.LockDockPanelsUpdate();
			
			// Create a control docked
			uc1 = new UserControl1();
			this.Controls.Add(uc1);
			dm.DockControl(uc1, this, DockingStyle.Right, 200);

			// Create a control floating
			uc2 = new UserControl1();
			this.Controls.Add(uc2);
			dm.FloatControl(uc2, new Rectangle(300, 300, 200, 200));

			// Create a hidden control docked
			uc3 = new UserControl1();
			this.Controls.Add(uc3);
			dm.DockControl(uc3, this, DockingStyle.Right, 200);
			dm.SetDockVisibility(uc3, false);

			// Create a hidden control floating
			uc4 = new UserControl1();
			this.Controls.Add(uc4);
			dm.FloatControl(uc4, new Rectangle(600, 600, 200, 200));
			dm.SetDockVisibility(uc4, false);

			dm.UnlockDockPanelsUpdate();
			this.Refresh();
		}

		bool showingFirst = true;
		private void menuItem2_Click(object sender, System.EventArgs e)
		{
//			dm.LockDockPanelsUpdate();
			
			// Swap visible groups
			if (showingFirst)
			{
				dm.SetDockVisibility(uc1, false);
				dm.SetDockVisibility(uc2, false);
				dm.SetDockVisibility(uc3, true);
				dm.SetDockVisibility(uc4, true);
			}
			else
			{
				dm.SetDockVisibility(uc3, false);
				dm.SetDockVisibility(uc4, false);
				dm.SetDockVisibility(uc1, true);
				dm.SetDockVisibility(uc2, true);
			}
			showingFirst = !showingFirst;

//			dm.UnlockDockPanelsUpdate();
//			this.Refresh();
		}
	}
}
