using System;
using System.Threading;
using Syncfusion.Windows.Forms.Grid;

namespace DockTest
{
	/// <summary>
	/// Summary description for UserControl1.
	/// </summary>
	public class UserControl1 : System.Windows.Forms.UserControl
	{
		private Syncfusion.Windows.Forms.Grid.GridControl gridControl1;

		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public GridControl Grid
		{
			get { return gridControl1; }
			set { gridControl1 = value; }
		}

		public UserControl1()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

			// Load data in to grid
			PopulateGrid();

			// Pause
			for (long l = 0; l < 100; l++)
				Thread.Sleep(1);
		}

		#region Data generation

		private void PopulateGrid()
		{
			this.gridControl1.RowCount = 100;
			this.gridControl1.ColCount = 8;

			Random r = new Random();
			this.gridControl1.CommandStack.Enabled = false;
			this.gridControl1.BeginUpdate();
			for (int row = 1; row <= this.gridControl1.RowCount; ++row)
			{
				for(int col = 2; col <= this.gridControl1.ColCount; ++col)
				{
					object cellValue;

					cellValue = 0;
					if ( 2 == col )
					{
						cellValue = RandomName(r) as object;
					}
					else if(3 == col) 
					{
						cellValue = (Int32)((uint)r.Next(1000));
					}
					else if(4 == col) 
					{
						cellValue = r.Next(42000) / 200.0;
					}
					else if(5 == col) 
					{
						cellValue = r.Next(100000) / 200.0;
					}
					else if(6 == col)
					{
						cellValue = (Int32)((uint)r.Next(100));
					}
					else if(7 == col) 
					{
						cellValue = r.Next(1042) / 200.0;
					}
					else if(8 == col) 
					{
						cellValue = new Percentage((uint)(r.Next(100) % 100));
					}
				
					this.gridControl1[row, col].CellValue =	cellValue;
					this.gridControl1[row, col].ImageList = this.gridControl1.ColStyles[col].ImageList;
				}
			}
			this.gridControl1.EndUpdate();
			this.Refresh();
		}

		private string RandomName(Random r)
		{
			string [] names = {"One", "Two", "Three", "Four", "Five"};

			int instrumentIdx = r.Next(14201) % (names.Length);

			return names[instrumentIdx];
		}

		#region Custom type class

		public class Percentage : IComparable
		{
			private uint percentage;

			public Percentage(uint percentage)
			{
				this.percentage = percentage;
			}

			public uint Value
			{
				get { return this.percentage; }
				set { this.percentage = value; }
			}

			public override string ToString()
			{
				return Value.ToString() + "%";
			}


			#region IComparable Members

			public int CompareTo(object obj)
			{
				Percentage toCompare = obj as Percentage;
				if ( null != toCompare )
				{
					return (int)(Value - toCompare.Value);
				}
				return -1;
			}
			#endregion
		}

		#endregion Custom type class

		#endregion Data generation

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridControl1 = new Syncfusion.Windows.Forms.Grid.GridControl();
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridControl1
			// 
			this.gridControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridControl1.Location = new System.Drawing.Point(8, 8);
			this.gridControl1.Name = "gridControl1";
			this.gridControl1.Size = new System.Drawing.Size(136, 136);
			this.gridControl1.SmartSizeBox = false;
			this.gridControl1.TabIndex = 0;
			this.gridControl1.Text = "gridControl1";
			// 
			// UserControl1
			// 
			this.Controls.Add(this.gridControl1);
			this.Name = "UserControl1";
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion
	}
}
